<template>
	<div class="column q-pa-md q-gutter-md">
		<div class="row items-center q-gutter-md">
			<q-select v-model="type" :options="[
				{ label: 'Receipts', value: 'sync_dcc' },
				{ label: 'IPD Sales', value: 'sync_ipd_sales' },
				{ label: 'OPD Sales(Dues Corporate)', value: 'sync_opd_sales' }
			]" map-opttions emit-value />
			<date-combo v-model="date" />
			<q-btn @click="syncTally" color="primary" label="Sync Tally" />
			<q-btn @click="downloadZip" color="primary" label="Download ZIP" />
		</div>
		<div class="row items-center q-gutter-md">
			<item-labek>Status</item-labek>
			<div>{{ status.message }}</div>
			<div>Created: {{ status.created }}</div>
			<div>Altered: {{ status.altered }}</div>
			<div>Response: {{ status.response }}</div>
		</div>
	</div>

</template>
<script>
export default {
	components: {
		DateCombo: Vue.defineAsyncComponent(() => import(`components/widgets/date-combo.vue`))
	},
	data() {
		return {
			type: null,
			date: {
				from: null,
				to: null
			},
			status: {
				message: '',
				created: '',
				altered: '',
				response: ''
			}
		}
	},
	methods: {
		syncTallys() {

		},
		downloadZip() {
			let self = this
			let postData = {}
			postData.form_data = { From_Date: this.date.from, To_Date: this.date.to }
			postData.Procedure = this.type
			postData.Module_Name = 'Tally_Synchronization'
			this.status.message = 'Request Sent'
			axios.post('welcome/action', objectToFormData(postData)).then(async ({ data }) => {
				let payload = data.datatype.result
				if (payload.binary !== undefined) {
					self.status.message = 'Generating Zip'
					var zip = new JSZip();
					for (const name in payload.binary) {
						let data = payload.binary[name]
						zip.file(name + '.xml', data);
					}
					var content = await zip.generateAsync({ type: "blob" })
					var zipURL = URL.createObjectURL(content);
					var tempLink = document.createElement('a');
					tempLink.href = zipURL;
					tempLink.download = 'tally.zip'
					tempLink.click();
					URL.revokeObjectURL(tempLink.href);
					tempLink.remove();
					self.status.message = 'Zip Generated'

				}
			})
		}
	}
}
</script>	
</script>